M = 4;
n = 64;

[L, H, w] = genGrids(M, n, [15 0]);

[X Y] = meshgrid(0.0:0.1:10.0, ...              % 10m x 10m patch
                     0.0:0.1:10.0);             %    at 10cm resolution
HI = zeros(size(X));                            % height values

t = 0.0;                                        % time
for m=1:M
  [x y] = meshgrid(-L{m}/2:L{m}/n:L{m}/2, -L{m}/2:L{m}/n:L{m}/2);
  h = n^2*real(ifft2(H{m}.*exp(i*w{m}*t)));     % Eq. (6); inverse FFT
  h = [h, h(:, 1); h(1, :), h(1, 1)];           % periodic boundaries

  XI = mod(X, L{m})-L{m}/2.0;                   % surface locations
  YI = mod(Y, L{m})-L{m}/2.0;                   %    on grid m
  
  HI = HI + interp2(x, y, h, XI, YI);           % add height values
end

figure
mesh(X, Y, HI)
